/**********************************************************************/
/* F2PCV - FMP -> P.M.D. data converter by JUD(T.Terata)              */
/* Definitions                                                        */
/**********************************************************************/
#ifndef FPD_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include "../common/f2pcvif.h"

#define DN_PART_PHELEM 12
#define DN_PART_PDELEM 11
#define DN_PART_FELEM 11
#define DN_MAX_CONTROLCODE 512
#define DH_BMESSAGES 0
#define DN_SIZE_LINEBUFFER 1024
#define DN_SIZE_STACKUNIT 64
#define DN_SIZE_MTBUNIT 64
#define DN_SIZE_PMDFOOTREAL 25
#define DN_SIZE_PMDHEADREAL 27
#define DN_SIZE_PMDHEADBUF 28
#define DN_MAX_OUTUNITSIZE 1024
#define DN_SIZE_VOICEPMD 26
#define DN_SIZE_VOICEFMP 25
#define DN_VOFFSET_OPI 28
#define DN_VOFFSET_OVI 50

#define D_VERSION_OUTPMDDATA 0x47

#define DN_SIZE_OUTBUFUNIT 512

#define D_PARTTYPE_FM 0
#define D_PARTTYPE_SSG 1
#define D_PARTTYPE_PCM 2
#define D_PARTTYPE_UK -1

#define D_OBJ_TIE ((char)(0x66))
#define D_OBJ_SLUR ((char)(0x7A))

#define DS_DEBUGFILENAMESTR "F2PCVTEST"

/*--------------------------------------------------------------------*/
/* \(PMD) */
typedef	struct	_t_ppartstate{
	int use;		/* D_ON/D_OFF */
	int partlength;	/* Yp[ǧ݂̒(I[܂) */
	int bufsize;	/* ݂̃obt@TCY */
	short offset;	/* olcf[^Ɏ܂Ƃ̃ItZbgl */
	short nouse;
	char *buffer;	/* Yp[g̃obt@AhX */
	char *bufcur;	/* ̃obt@݃AhX */
}T_PPARTSTATE;

/* \(FMP) */
typedef	struct	_t_fpartstate{
	int use;
	int parttype;	/* p[g^Cv */
	int ppartnum;	/* ϊ̃p[gԍ */
	char *pdata;	/* p[gf[^擪AhX */
	char *lladdr;	/* 'L' ݂iׂjAhX */
	char **lsaddr;	/* '['[vJnL݂iׂjAhXQ */
	char **lscur;	/* AhXQŎ̒l */
	char *nextlp;	/* 'L'܂'['oꂷAhX */
}T_FPARTSTATE;

/* control codes */
typedef	struct	_t_tcode{
	int cont;
	int f_opelen[3];	/* ϊÕIy[V */
	int f_datalen[3];	/* ϊÕf[^ */
	int p_opelen;		/* ϊ̃Iy[V */
	int p_datalen;		/* ϊ̃f[^ */
	char fcode[7];		/* ϊÕf[^ VoCg(7c,01n̂ߑ) */
	char pcode1;		/* ϊ̃f[^ PoCg */
	int convtype;		/* 0: 1:u 2:f[^tPu */
						/* 3:f[^ȂPu 4:ʏ */
}T_TCODE;








#endif
#define FPD_H
