/**********************************************************************/
/* PMDRC - P.M.D. reversal compiler by JUD(T.Terata)                  */
/* Definitions                                                        */
/**********************************************************************/
#ifndef PRD_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include "../common/pmdrcif.h"

/*--------------------------------------------------------------------*/
/* {萔 */
#define D_LAST 0
#define D_NOTLAST 1

#ifndef JST_D_ONOFF
#define D_ON 1
#define D_OFF 0
#endif
#define JST_D_ONOFF

#define DS_DEFINE_PPZEXTEND "#PPZExtend  abcdefgh\n"
#define DS_DEFINE_FM3EXTEND "#FM3Extend  XYZ\n"

#define DS_DEFINE_PZINAME   "#PPZFile    %s\n"
#define DS_DEFINE_PPSNAME   "#PPSFile    %s\n"
#define DS_DEFINE_PPCNAME   "#PCMFile    %s\n"
#define DS_DEFINE_TITLE     "#Title      %s\n"
#define DS_DEFINE_COMPOSER  "#Composer   %s\n"
#define DS_DEFINE_ARRENGER  "#Arranger   %s\n"
#define DS_DEFINE_MEMO      "#Memo       %s\n"

#define DS_OK "OK"
#define DS_NG "NG"

#define DC_ADDSYMBOL '&'
/*--------------------------------------------------------------------*/
/* 萔 */

#define DN_SIZE_LINEBUFFER 1024
#define DN_MAX_TRACKNUM 21
//#define DN_MAX_OBJSIZE 32768
#define DN_MAX_CONTROLCODE 256
#define DN_MAX_OUTUNITSIZE 1024 /* o̓obt@ݒP */
/* e[uݒP */
#define DN_GETBON 20
#define DN_GETBOC 16
#define DN_GETBOM 16
#define DN_SIZE_MTBUNIT 64
#define DN_MAX_NOTELENFREQ 192

#define DN_LENGTH_DEFLIMIT 98765

/* WZo萔 */
#define DN_PCT_12P 0.05
#define DN_PCT_21P 0.9
#define DN_PCT_31P 0.7
#define DN_PCT_32P 0.2
#define DN_PCT_42P 0.3
#define DN_PCT_52P 0.25
#define DN_PCT_61P 0.1

/* obt@nh */
#define DH_BMESSAGES 0
#define DH_BMML 1
#define DH_BDUMP 2
#define DH_BSDUMP 3
#define DH_BVOICE 4
#define DH_BDEFINE 5
#define DH_BLAST 6

/* olctH[}bg萔 */
#define DC_START_CHAR_FMSSG 'A'
#define DC_START_CHAR_ADPCM 'J'
#define DC_START_CHAR_FM3EX 'X'
#define DC_START_CHAR_PPZ 'a'
#define DN_START_NUM_FMSSG 0
#define DN_START_NUM_ADPCM 9
#define DN_START_NUM_FM3EX 10
#define DN_START_NUM_PPZ 13
/* olcf[^̂elFf[^TCY */
#define DN_FMTONE_SIZE 26
/* #MEMO ̍ő */
#define DN_MAX_MEMOPOINT 128

/* pR}h萔 */
#define D_OP_TLINIT 1
#define D_OP_TLADD 2
#define D_OP_TLLSTART 3
#define D_OP_TLLEND 4
#define D_OP_TLTOTAL 5
#define D_OP_TLBEFOREL 6
#define D_OP_TLFINDL 7
#define D_OP_TLFINDCL 8
#define D_OP_TLTLEVEL 9
#define D_OP_TLLEVEL 10

/* e[uʗp */
#define D_LC_NOTE 1
#define D_LC_CODE 2

/* ߐ[h萔 */
#define D_BAR_UNDEFINE -1
	/*  */
#define D_BAR_FULLAUTO1 1
	/* Lȍ~Sp[gAzenlen̔{ */
#define D_BAR_FULLAUTO2 2
	/* Lȍ~Sp[gȂASp[gzenlen̔{ */
#define D_BAR_FULLAUTO3 3
	/* Lȍ~Sp[gȂAŒp[gSp[g̍ŏ{ */
#define D_BAR_HALFAUTO5 4
	/*  L݂ȂASp[gzenlen̔{ */
#define D_BAR_TOPSTART 5
	/* N_f[^擪ɌŒ /B2 w肳ꂽꍇ */

/* Lȍ~zenlenŁALȑOLOtzenlenPʂ */
#define D_BAR_HALFAUTO1 101
	/*  Lȍ~Sp[gAzenlen̔{ */
	/* w肪barlenŕ */
#define D_BAR_HALFAUTO2 102
	/*  L݂ȂASp[g */
	/* dݔfɂ鎩 */
#define D_BAR_MANUAL 999
	/* ǂ̖@ɂĂ͂܂ȂꍇAߕsȂ */
#define D_BAR_FORCEDMANUAL 998
	/* Iɋ֎~BߕsȂ */
#define D_BAR_FORCEDAUTO 997
	/* IɎ{BߕKs */

/* notes , portaments , r 28bytes V1.21 */
typedef	struct	_t_bon{
	long toffset;	/* n_̑ */
	short length;	/* IuWFNg */
	char note1;		/* note/|^gn_/control-code */
	char note2;		/* |^gI_/control-value */
	char trans;		/* ݐσgX|[Y */
	char mtrans;	/* }X^[gX|[Y */
	char oct;		/* ݂oct */
	char ties;		/* ^CEX[ (&/&&) */
	char barline[2];/* ߐ */
	char nocombine;	/* 㑱Ƃ̃RoC֎~ */
	char nouse6;
	char *address;	/* R[h̃AhXۊǁo͑OɎQƂ V1.21 */
	struct _t_bon *newarea;	/* ̗̈̎n_addr NULL:Empty */
	struct _t_bon *befarea;	/* Ö̗̎n_addr NULL:StartPoint */
}T_BON;
/* i[R[h */
/* ExA|^gA^CEX[A󔒁A]n */

/* controlles 24bytes */
typedef	struct	_t_boc{
	long toffset;	/* n_̑ */
	char code;		/* code */
	char value;		/* ߒ(Z) [v(]) */
	char nouse1;
	char disable;	/* D_ON:ׂς */
	char barline[2];/* ߐ */
	char nocombine;	/* 㑱Ƃ̃RoC֎~ */
	char nouse6;
	char *address;	/* R[h̃AhXۊǁo͑OɎQƂ */
	struct _t_boc *newarea;	/* ̗̈̎n_addr NULL:Empty */
	struct _t_boc *befarea;	/* Ö̗̎n_addr NULL:StartPoint */
}T_BOC;

/* mastertrack 16bytes */
typedef	struct	_t_bom{
	long toffset;	/* n_̑ */
	char code;
	unsigned char barlen;	/* ߒ */
	char nouse1;
	char last;
	struct _t_bom *newarea;	/* ̗̈̎n_addr NULL:Empty */
	struct _t_bom *befarea;	/* Ö̗̎n_addr NULL:StartPoint */
}T_BOM;

/* track status 32bytes x 21 */
typedef	struct	_t_tstatus{
	char use;		/* gpꍇ:D_ON ݂Ȃyђ[:D_OFF */
	char partname;	/* O͌Œ A-F G-I J X-Z a-h */
	char offset;	/* p[g擪r%1ɑΉItZbg */
	char startoct;	/* ŏoR}hŎw肷l */
	int partlen;	/* p[g̒ 0x80̓oꂷl_clock */
	T_BON *naddr;	/* notes̈̃̃AhX */
	T_BOC *caddr;	/* controlles̈̃̃AhX */
	char *text;		/* ǂݍ݃t@C̃p[g擪AhX */
	int tracktotal;	/* gbNŜ̒i[v[]0̎-1j*/
	int tracklenbl;	/* gbNLO̒iLȂꍇ-1j*/
	int tracklenal;	/* gbNL̒iLȂꍇ-1j*/
}T_TRACKTABLE;

/* FM-Tone Bank 27(26)bytes */
typedef	struct	_t_fmt{
	unsigned char tnumber;	/* ToneNumber */
	unsigned char dtml[4];	/* 1/3-DT/4-ML */
	unsigned char tl[4];	/* 1/7-TL */
	unsigned char ksar[4];	/* 1/2-KS/5-AR */
	unsigned char amdr[4];	/* 2/1-AMS/5-DR */
	unsigned char sr[4];	/* 3/5-SR */
	unsigned char slrr[4];	/* 4-SL/4-RR */
	unsigned char fbal;		/* 2/3-FeedBack/3-Algorhythm */
	unsigned char nextnum;	/* ToneNumber */
}T_FMT;

/* FM-Tone Format(INTERNAL) */
typedef	struct	_t_ifmt{
	int i_ml;	/* ML */
	int i_dt;		/* DT */
	int i_ar;		/* AR */
	int i_dr;		/* DR */
	int i_sl;		/* SL */
	int i_sr;		/* SR */
	int i_rr;		/* RR */
	int i_tl;		/* TL */
	int i_ks;		/* KS */
	int i_ams;		/* AMS */
}T_IFMT;
/* FM-Tone Format(OUTPUT) */
typedef	struct	_t_ofmt{
	float f_freq;	/* ML */
	int i_det;		/* DT */
	int i_ar;		/* AR */
	int i_d1r;		/* DR */
	int i_d1l;		/* SL */
	int i_d2r;		/* SR */
	int i_rr;		/* RR */
	int i_out;		/* TL */
	int i_rs;		/* KS */
}T_OFMT;

/* control codes */
typedef	struct	_t_tcode{
	int cont;
	char code1;		/* PoCg */
	char code2;		/* 0x00ȊÔƂ QoCg */
	char dmusk;		/* QoCgڂ𔻒ft}XN(0x80̎bit7𔻒f) */
	char nouse;		/* nouse */
	int datasize;	/* ɑf[^TCY */
	int format;		/* tH[}bg */
	int level;
		/*-VtH[}bg---------------------*/
		/* F                             */
		/*  0: */
		/*  1:expset֐R[A{(FM3Ex/PPZEx) */
		/*  2: */
		/*  3:Y\邾 */
		/*  4:f[^(1byte)tĕ\( -128/127) */
		/*  5:f[^(1byte)tĕ\(Ȃ 0/255) */
		/*  6:2bytesȏ̃f[^tĕ\(l͕ʓr) */
		/*  7:f[^(1byte)tĕ\( -128/127) */
		/*  8:f[^(1byte)tĕ\( -128/127) [͖o */
		/* xF                           */
		/*  0:ɔ\AԃIuWFNgɂϊȂ */
		/*  1:擾sȂ */
		/*  2:O[oɕϊ */
		/*  3:So͎w莞̂ݎ擾 */
		/*  4:ʏ\ */
		/*  5:ȗ\ł\ */
		/*------------------------------------*/
	int table;		/* table 1:note 0:control */
	int steps;		/* D_ON/1:Lꍇ D_OFF/0:[ */
	char *str;		/* MML */
	char *outformat;/* MMLo͎tH[}bg format=6̎̂ݗL */
					/* '#':PoCg '$':QoCg */
					/* '(':PoCg ')':QoCg */
					/* '_':PoCgȂ '~':QoCgȂ */
					/* 'a':WrbgȂ 'b':VrbgȂ */
					/* 'z':tWrbgȂ 'y':tVrbgȂ */
					/* ' ':PoCg\Ȃ */
					/* ȊO:̂܂ܕ\ */
					/* ex) "_#$#"  1(unsigned)/1/2/1 */
}T_TCODE;

/* VXeϐ */
/* i`j0x00pfBOBʂɏ̂ */
typedef	struct	_t_ginfo{
	char c_varsion;		/* mc.exeo[W */
	char nouse1;		
	char nouse2;		
	char nouse3;		
	long l_mctotal;		/* mc.exeɂtotalclock -1 */
	long l_mcloop;		/* mc.exeɂloopclock -1 */
	char *cp_voice;		/* FMF`擪AhX */
	char *cp_dtaddr;	/* eeLXg`AhXQ̃AhX */
	char *cp_pziname;	/* PPZFilẽAhX */
	char *cp_ppsname;	/* PPSFilẽAhX */
	char *cp_ppcname;	/* PPCFilẽAhX */
	char *cp_title;		/* TitlẽAhX */
	char *cp_composer;	/* Composer̃AhX */
	char *cp_arrenger;	/* Arrenger̃AhX */
	char *cps_memo[DN_MAX_MEMOPOINT];
						/* memõAhXz */
	int i_nmemo;		/* memo -1 */
	int i_fPPZExtend;	/*-PPZExtend 0:OFF 1:ON */
	int i_fFM3Extend;	/*-FM3Extend 0:OFF 1:ON */
	int i_Zcount;		/*-ZR}h̓o */
	int i_Znotonline;	/*-ZR}hߐȊOɑ݂ 0:no 1;yes */
	int i_Fcount;		/*-FR}ho */
	int i_Lcount;		/*-LR}ho */
	int i_ILLcount;		/*-[vǏ[v"]0"R}ho */
}T_GINFO;




#endif
#define PRD_H
